' TodPal.bas
' written in JustBASIC by CirothUngol
' for the CCGHQ Shandalar Forums at slightlymagic.net
'
' This program translates the "TodPal.tr" text file from
' Microprose's Magic: The Gathering into a "duel.plogpal"
' palette file for use with the MtG Image Decoding Tools
' by CTPAX-X Team at http://www.CTPAX-X.ru/

NOMAINWIN
DIM Pal(4, 255)
DIM fileInfo$(1, 1)

' check for file existence
IF JBfileExists(DefaultDir$, "TodPal.tr") = 0 THEN END

' fill Palette with FFs
FOR I = 0 TO 255
    FOR X = 1 TO 3
        Pal(X, I) = 255
    NEXT X
    Pal(4, I) = 1
NEXT I

' open text Palette and fill array
' format "pal# - val1 val2 val3
OPEN "TodPal.tr" FOR INPUT AS #ReadPal
WHILE EOF(#ReadPal) = 0
    LINE INPUT #ReadPal, Temp$
    FOR I = 1 TO 3
        Pal(I, VAL(WORD$(Temp$, 1))) = VAL(WORD$(Temp$, (I + 2)))
    NEXT I
    Pal(4, VAL(WORD$(Temp$, 1))) = 1
WEND
CLOSE #ReadPal

' reset incorrect values
Pal(4, 0) = 0
Pal(2, 252) = 255

' write array to new Palette
OPEN "duel.plogpal" FOR OUTPUT AS #WritePal
#WritePal CHR$(0); CHR$(3); CHR$(0);  CHR$(1);
FOR I = 0 TO 255
    FOR X = 1 TO 4
        #WritePal CHR$(Pal(X, I));
    NEXT X
NEXT I
CLOSE #WritePal

END

' FUNCTION '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' JBfileExists(path$, filename$): Function
' Returns the number of files(filename$) in directory(path$)
' Wildcards "*" are allowed (eg. "*.txt")
' Dimension the array fileInfo$() at the beginning of your program
' I pulled this off the JustBASIC Forums, it was uncredited
 FUNCTION JBfileExists(path$, filename$)
    FILES path$, filename$, fileInfo$()
    JBfileExists = VAL(fileInfo$(0, 0))  'non zero is true
 END FUNCTION

